#include "stdafx.h"
#include "ROM.h"

/////////////////////////////////////////////////////////////////////////////
//
//  Modifications:
//
//  12/10/2000  BCA and BPF     Moved code into its own source file
//          
/////////////////////////////////////////////////////////////////////////////


ROM::ROM(word_t base,int mem_size):MemoryObject()
{
	assert((mem_size >=0) && (mem_size <= 0xffff));

	base_addr = base;
    size = mem_size;
	top_addr = base_addr + size;

	// Allocate memory
	mem = new byte_t[size];
    assert(mem!=NULL);
}

ROM::~ROM ()
{
	// Free memory
	if(mem!=NULL)
	    delete[] mem;
}

byte_t ROM::Read(word_t address)
{
  return(mem[address-base_addr]);
}

void ROM::Program(word_t address, byte_t data)
{
	mem[address-base_addr] = data;
}